// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 This tag adds script files to include to the rendered page.
  Direct calls can also be registered via special attributes,
  This will be deprecated (because of CSP) in later versions.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ScriptTagDeclaration}.
 */
public class UIScript
    extends UIComponentBase  {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Script";

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.Script";

  private java.lang.String onload;
  private java.lang.String file;
  private java.lang.String onunload;
  private java.lang.String script;
  private java.lang.String onexit;
  private java.lang.String onsubmit;

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Alternatively include a custom script file via the file attribute and use
   <code>Tobago.registerListener(myFunction, Tobago.Phase.DOCUMENT_READY);</code> or
   <code>Tobago.registerListener(myFunction, Tobago.Phase.WINDOW_LOAD);</code>

  @deprecated*/
  @Deprecated
  public java.lang.String getOnload() {
    if (onload != null) {
      return onload;
    }
    ValueExpression ve = getValueExpression("onload");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setOnload(java.lang.String onload) {
    this.onload = onload;
  }

  public java.lang.String getFile() {
    if (file != null) {
      return file;
    }
    ValueExpression ve = getValueExpression("file");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setFile(java.lang.String file) {
    this.file = file;
  }

  /**
  Alternatively include a custom script file via the file attribute and use
   <code>Tobago.registerListener(myFunction, Tobago.Phase.BEFORE_UNLOAD);</code>

  @deprecated*/
  @Deprecated
  public java.lang.String getOnunload() {
    if (onunload != null) {
      return onunload;
    }
    ValueExpression ve = getValueExpression("onunload");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setOnunload(java.lang.String onunload) {
    this.onunload = onunload;
  }

  /**
  Alternatively include a custom script file via the file attribute.

  @deprecated*/
  @Deprecated
  public java.lang.String getScript() {
    if (script != null) {
      return script;
    }
    ValueExpression ve = getValueExpression("script");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setScript(java.lang.String script) {
    this.script = script;
  }

  /**
  Alternatively include a custom script file via the file attribute and use
   <code>Tobago.registerListener(myFunction, Tobago.Phase.BEFORE_EXIT);</code>

  @deprecated*/
  @Deprecated
  public java.lang.String getOnexit() {
    if (onexit != null) {
      return onexit;
    }
    ValueExpression ve = getValueExpression("onexit");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setOnexit(java.lang.String onexit) {
    this.onexit = onexit;
  }

  /**
  Alternatively include a custom script file via the file attribute and use
   <code>Tobago.registerListener(myFunction, Tobago.Phase.BEFORE_SUBMIT);</code>

  @deprecated*/
  @Deprecated
  public java.lang.String getOnsubmit() {
    if (onsubmit != null) {
      return onsubmit;
    }
    ValueExpression ve = getValueExpression("onsubmit");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setOnsubmit(java.lang.String onsubmit) {
    this.onsubmit = onsubmit;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    onload = (java.lang.String) values[1];
    file = (java.lang.String) values[2];
    onunload = (java.lang.String) values[3];
    script = (java.lang.String) values[4];
    onexit = (java.lang.String) values[5];
    onsubmit = (java.lang.String) values[6];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[7];
    values[0] = super.saveState(context);
    values[1] = onload;
    values[2] = file;
    values[3] = onunload;
    values[4] = script;
    values[5] = onexit;
    values[6] = onsubmit;
    return values;
  }


}